import java.io.*;
import java.util.*;


abstract class f_xj
{
abstract double func(double x[]);
}

public class Arithmetic_Optimization_Algorithm
{
double[] Lower;
double[] Upper;
int N;
int D;
f_xj ff;
int Maxiter;
double[][] XX;
double[][] XXNEW;
double[] fitness;
double[] BEST;
double MOP_Max=1.0;
double MOP_Min=0.2;
double alpha=5.0;
double mu=0.499;
double MOP;
double MOA;
double eps=0.00000000000001;


	public Arithmetic_Optimization_Algorithm(double[] iLower, double[] iUpper, int iN, f_xj iff, int iMaxiter)
	{
	ff=iff;
	Lower=iLower;
	Upper=iUpper;
	D=Lower.length;
	N=iN;
    Maxiter=iMaxiter;	
	XX=new double[N][D];
	XXNEW=new double[N][D];
    fitness=new double[N];
    BEST=new double[D];
	
	}
	
	  double[] getminval_index(double[] a)
	 {
	 double m=0.0;	 
	 double b[]=new double[a.length];
	 for(int i=0;i<a.length;i++)
	 {b[i]=a[i];}  
	 double minval=a[0];
	 for(int i=0;i<a.length;i++)
	 {if(a[i]<minval){minval=a[i];}}
	 for(int i=0;i<a.length;i++)
	 {if(b[i]==minval){m=i;break;}};
	 double[] dep=new double[2];
	 dep[0]=minval;
	 dep[1]=m;
	 return dep;	 
    } 

	void init()
	{
	   for(int i=0;i<N;i++)
	   {for(int j=0;j<D;j++)
	      {XX[i][j]=Lower[j]+(Upper[j]-Lower[j])*Math.random();}}	
	   
	   for(int i=0;i<N;i++)
	   {fitness[i]=ff.func(XX[i]);}
		
	   double[] aa=getminval_index(fitness);
	   int mindex=(int)aa[1];
	   for(int j=0;j<D;j++)
	   {BEST[j]=XX[mindex][j];}	
	   
	   
    }
    
    	  double[][] boundary(double[][] XX)
          { 
	        int NN=XX.length;
	        int DD=XX[0].length;  
	        for(int i=0;i<NN;i++)
   			   {for(int j=0;j<DD;j++)
      		    	{if((XX[i][j]<Lower[j])||(XX[i][j]>Upper[j]))
           		    {XX[i][j]=Lower[j]+((Upper[j]-Lower[j])*Math.random());}}}
   		    return XX;
	      }
		  
	      double[][] Update(double[][] TT, double[][] newTT)
	      {
		    int DD=TT[0].length;
		    int NN=TT.length;
		            
		  	for(int i=0;i<NN;i++)
		  	 {if(ff.func(newTT[i])<ff.func(TT[i]))
		     	{for(int j=0;j<DD;j++)
			   	 {TT[i][j]=newTT[i][j];}}}
			  return TT;
	      }
    

    double[][] solution()
    {
	    
	   init();
	   int iter=1;
	   while(iter<Maxiter)
	   {
		 MOP=1.0-(Math.pow((double)iter,1/alpha)/Math.pow(Maxiter,1/alpha)); 
		 MOA=MOP_Min+(double)iter*((MOP_Max-MOP_Min)/(double)Maxiter); 
		 for (int i=0;i<N;i++)
		 {
		    for(int j=0;j<D;j++)
		    {
			    
			    if(Math.random()<MOA)
			    {
				     if(Math.random()>0.5)
				     {XXNEW[i][j]=BEST[j]/(MOP+eps)*((Upper[j]-Lower[j])*mu+Lower[j]);}  
				     else
				     {XXNEW[i][j]=BEST[j]*(MOP)*((Upper[j]-Lower[j])*mu+Lower[j]);} 
				}
			    else
			    {
				     if(Math.random()>0.5)
				     {XXNEW[i][j]=BEST[j]-(MOP)*((Upper[j]-Lower[j])*mu+Lower[j]);}  
				     else
				     {XXNEW[i][j]=BEST[j]+(MOP)*((Upper[j]-Lower[j])*mu+Lower[j]);} 
				}
			 }	 
	     }  
		 XX=boundary(XX);
		 XX=Update(XX,XXNEW);
		 
		  for(int i=0;i<N;i++)
	      {fitness[i]=ff.func(XX[i]);}
		
	   double[] aa=getminval_index(fitness);
	   int mindex=(int)aa[1];
	   for(int j=0;j<D;j++)
	   {BEST[j]=XX[mindex][j];}	
		
	   iter++; 
	   } 
	    
	    double out[][]=new double[2][D];
		out[1][0]=ff.func(BEST);
		for(int i=0;i<D;i++)
		{out[0][i]=BEST[i];}
	    return out;
	   
	}


void toStringnew()
{
  double[][] out=solution();
  System.out.println("Optimized value = "+out[1][0]);
  for(int i=0;i<D;i++)
  {System.out.println("x["+i+"] = "+out[0][i]);}	
}


}